MESS=1

# a tiny compile is without Neogeo games
COREDEFS += -DTINY_COMPILE=1
COREDEFS += -DNEOFREE -DMESS

# Core xmess stuff
SOUNDS+=CUSTOM@
SOUNDS+=SAMPLES@
SOUNDS+=DAC@
SOUNDS+=DMADAC@
SOUNDS+=DISCRETE@
SOUNDS+=BEEP@

##  Vextrex, currently WAY too slow
#CPUS+=M6809@
#SOUNDS+=AY8910@
#OBJS += $(OBJ)/mess/machine/vectrex.o
#OBJS += $(OBJ)/mess/systems/vectrex.o
#OBJS += $(OBJ)/mess/vidhrdw/vectrex.o

##  Bally Astrocade, crashes in sound
#CPUS+=Z80@
#OBJS += $(OBJ)/sound/astrocde.o	 \
#		$(OBJ)/mess/vidhrdw/astrocde.o \
#		$(OBJ)/mess/machine/astrocde.o \
#		$(OBJ)/mess/systems/astrocde.o

##  Emerson Arcadia 2001
CPUS+=S2650@
OBJS += $(OBJ)/mess/systems/arcadia.o	\
		$(OBJ)/mess/sndhrdw/arcadia.o	\
		$(OBJ)/mess/vidhrdw/arcadia.o	\

##  Coleco Adam
CPUS+=Z80@
SOUNDS+=SN76496@
OBJS += $(OBJ)/mess/machine/adam.o
OBJS += $(OBJ)/mess/systems/adam.o
OBJS += $(OBJ)/mess/formats/adam_dsk.o

##  Coleco
CPUS+=Z80@
SOUNDS+=SN76496@
OBJS += $(OBJ)/mess/machine/coleco.o		\
		$(OBJ)/mess/systems/coleco.o        

##  Atari 7800
CPUS+=M6502@
CPUS+=M65C02@
CPUS+=M65SC02@

SOUNDS+=POKEY@
SOUNDS+=TIA@

OBJS += $(OBJ)/vidhrdw/tia.o				\
		$(OBJ)/machine/atari.o				\
		$(OBJ)/vidhrdw/atari.o				\
		$(OBJ)/vidhrdw/antic.o				\
		$(OBJ)/vidhrdw/gtia.o				\
		$(OBJ)/mess/systems/atari.o			\
		$(OBJ)/mess/machine/a7800.o			\
		$(OBJ)/mess/systems/a7800.o			\
		$(OBJ)/mess/vidhrdw/a7800.o

##  Apple ][ family
##  CPU already defined for Atari (6502)

SOUNDS+=AY8910@

OBJS += $(OBJ)/mess/vidhrdw/apple2.o		\
		$(OBJ)/mess/machine/apple2.o		\
		$(OBJ)/mess/systems/apple2.o		\
		$(OBJ)/mess/formats/ap2_dsk.o		\
		$(OBJ)/mess/formats/ap_dsk35.o		\
		$(OBJ)/mess/machine/ay3600.o		\
		$(OBJ)/mess/machine/applefdc.o		\
		$(OBJ)/mess/machine/8530scc.o		\
		$(OBJ)/mess/machine/sonydriv.o		\
		$(OBJ)/mess/machine/appldriv.o		\
		$(OBJ)/mess/machine/ncr5380.o
	  
##  TI 99/4A
CPUS+=TMS9900@
SOUNDS+=TMS5220@

OBJS += $(OBJ)/mess/machine/tms9901.o	\
		$(OBJ)/mess/machine/tms9902.o	\
		$(OBJ)/mess/machine/ti99_4x.o	\
		$(OBJ)/mess/machine/990_hd.o	\
		$(OBJ)/mess/machine/990_tap.o	\
		$(OBJ)/mess/machine/ti990.o		\
		$(OBJ)/mess/machine/mm58274c.o	\
		$(OBJ)/mess/machine/994x_ser.o	\
		$(OBJ)/mess/machine/at29040.o	\
		$(OBJ)/mess/machine/99_dsk.o	\
		$(OBJ)/mess/machine/99_ide.o	\
		$(OBJ)/mess/machine/99_peb.o	\
		$(OBJ)/mess/machine/99_hsgpl.o	\
		$(OBJ)/mess/machine/99_usbsm.o	\
		$(OBJ)/mess/machine/smc92x4.o	\
		$(OBJ)/mess/machine/strata.o	\
		$(OBJ)/mess/machine/rtc65271.o	\
		$(OBJ)/mess/machine/geneve.o	\
		$(OBJ)/mess/machine/990_dk.o	\
		$(OBJ)/mess/sndhrdw/spchroms.o	\
		$(OBJ)/mess/systems/ti990_4.o	\
		$(OBJ)/mess/systems/ti99_4x.o	\
		$(OBJ)/mess/systems/ti99_4p.o	\
		$(OBJ)/mess/systems/geneve.o	\
		$(OBJ)/mess/vidhrdw/911_vdt.o	\
		$(OBJ)/mess/vidhrdw/733_asr.o	\

## Tandy Coco 1/2/3

CPUS+=M6809E@
SOUNDS+=AY8910@

OBJS +=	$(OBJ)/mess/machine/6883sam.o	\
		$(OBJ)/mess/machine/cococart.o	\
		$(OBJ)/mess/machine/ds1315.o	\
		$(OBJ)/mess/machine/m6242b.o	\
		$(OBJ)/mess/machine/dragon.o	\
		$(OBJ)/mess/vidhrdw/dragon.o	\
		$(OBJ)/mess/systems/dragon.o	\
		$(OBJ)/mess/formats/cocopak.o	\
		$(OBJ)/mess/formats/coco_cas.o	\
		$(OBJ)/mess/formats/coco_dsk.o	\
		$(OBJ)/mess/devices/coco_vhd.o	\

## Odyssey 2

CPUS+=I8048@
CPUS+=I8039@
OBJS += $(OBJ)/mess/machine/odyssey2.o \
		$(OBJ)/mess/vidhrdw/odyssey2.o \
		$(OBJ)/mess/sndhrdw/odyssey2.o \
		$(OBJ)/mess/systems/odyssey2.o

# MESS specific core $(OBJ)s
COREOBJS += \
	$(EXPAT)						\
	$(ZLIB)							\
	$(OBJ)/cheat.o					\
	$(OBJ)/vidhrdw/tms9928a.o		\
	$(OBJ)/machine/8255ppi.o		\
	$(OBJ)/machine/random.o			\
	$(OBJ)/machine/6522via.o		\
	$(OBJ)/machine/6821pia.o		\
	$(OBJ)/machine/z80fmly.o		\
	$(OBJ)/machine/idectrl.o		\
	$(OBJ)/machine/6532riot.o		\
	$(OBJ)/mess/mess.o				\
	$(OBJ)/mess/image.o				\
	$(OBJ)/mess/system.o			\
	$(OBJ)/mess/device.o			\
	$(OBJ)/mess/hashfile.o			\
	$(OBJ)/mess/inputx.o			\
	$(OBJ)/mess/unicode.o			\
	$(OBJ)/mess/artworkx.o			\
	$(OBJ)/mess/mesintrf.o			\
	$(OBJ)/mess/filemngr.o			\
	$(OBJ)/mess/tapectrl.o			\
	$(OBJ)/mess/compcfg.o			\
	$(OBJ)/mess/utils.o				\
	$(OBJ)/mess/eventlst.o			\
	$(OBJ)/mess/videomap.o			\
	$(OBJ)/mess/mscommon.o			\
	$(OBJ)/mess/pool.o				\
	$(OBJ)/mess/cheatms.o			\
	$(OBJ)/mess/opresolv.o			\
	$(OBJ)/mess/mui_text.o			\
	$(OBJ)/mess/infomess.o			\
	$(OBJ)/mess/formats/ioprocs.o	\
	$(OBJ)/mess/formats/flopimg.o	\
	$(OBJ)/mess/formats/cassimg.o	\
	$(OBJ)/mess/formats/basicdsk.o	\
	$(OBJ)/mess/formats/pc_dsk.o	\
	$(OBJ)/mess/devices/mflopimg.o	\
	$(OBJ)/mess/devices/cassette.o	\
	$(OBJ)/mess/devices/cartslot.o	\
	$(OBJ)/mess/devices/printer.o	\
	$(OBJ)/mess/devices/bitbngr.o	\
	$(OBJ)/mess/devices/snapquik.o	\
	$(OBJ)/mess/devices/basicdsk.o	\
	$(OBJ)/mess/devices/flopdrv.o	\
	$(OBJ)/mess/devices/harddriv.o	\
	$(OBJ)/mess/devices/idedrive.o	\
	$(OBJ)/mess/devices/dsk.o		\
	$(OBJ)/mess/devices/z80bin.o	\
	$(OBJ)/mess/devices/chd_cd.o	\
	$(OBJ)/mess/machine/6551.o		\
	$(OBJ)/mess/machine/smartmed.o	\
	$(OBJ)/mess/vidhrdw/m6847.o		\
	$(OBJ)/mess/vidhrdw/m6845.o		\
	$(OBJ)/mess/machine/msm8251.o  \
	$(OBJ)/mess/machine/tc8521.o   \
	$(OBJ)/mess/vidhrdw/v9938.o    \
	$(OBJ)/mess/vidhrdw/crtc6845.o \
	$(OBJ)/mess/machine/28f008sa.o \
	$(OBJ)/mess/machine/am29f080.o \
	$(OBJ)/mess/machine/rriot.o    \
	$(OBJ)/mess/machine/riot6532.o \
	$(OBJ)/machine/pit8253.o  \
	$(OBJ)/machine/mc146818.o \
	$(OBJ)/mess/machine/uart8250.o \
	$(OBJ)/mess/machine/pc_mouse.o \
	$(OBJ)/mess/machine/pclpt.o    \
	$(OBJ)/mess/machine/centroni.o \
	$(OBJ)/machine/pckeybrd.o \
	$(OBJ)/mess/machine/d88.o      \
	$(OBJ)/mess/machine/nec765.o   \
	$(OBJ)/mess/machine/wd179x.o   \
	$(OBJ)/mess/machine/serial.o   \
	$(OBJ)/mess/formats/wavfile.o
