#ifndef __GP2X_SDL_H__
#define __GP2X_SDL_H__

#include <SDL.h>
#include <SDL_ttf.h>

SDL_Surface* gp2x_init_sdl( void );
void gp2x_fini_sdl        ( void );

void gp2x_render_text         ( SDL_Surface* screen, TTF_Font* font, const char* string, int x, int y, int color );
void gp2x_render_text_center_x( SDL_Surface* screen, TTF_Font* font, const char* string, int y, int color );

void gp2x_outlined_rect( SDL_Surface* screen, int x, int y, int width, int height, int color );

TTF_Font* gp2x_load_ttf_font   ( const char* font_file, int font_size );
void gp2x_unload_ttf_font      ( TTF_Font* font );

SDL_Color gp2x_translate_color( int int_color );

#endif   /* __GP2X_SDL_H__ */
