#include "gp2x_sysdep_vkeyb.h"
#include "unix/keycodes.h"

///////////////////////////////////

// TODO:Handle keycodes that need shift implicitly

char* keyb_ti99_4a[] = {

//   0123456789ABCDEF0123456789A
	"        1234567890=   <sl> ", // 0
	"         qwertyuiop/       ", // 1
	"          asdfghjkl; enter ", // 2
	" shift     zxcvbnm,. shift ", // 3
	"      ctrl  space    fctn  ", // 4
	NULL                           // 5
};

char* shift_keyb_ti99_4a[] = {

//   0123456789ABCDEF0123456789A
	"        !@#$%^&*()+   <sl> ", // 0
	"         QWERTYUIOP-       ", // 1
	"          ASDFGHJKL: enter ", // 2
	" shift     ZXCVBNM<> shift ", // 3
	"      ctrl  space    fctn  ", // 4
	NULL                           // 5
};

gp2x_vkeyb_entry keyb_ent_ti99_4a[] = {

    /* first row */

    { KEY_1,         8,  0, 1, 1, GP2X_VKEYB_NORMAL_KEY, 0 },
    { KEY_2,         9,  0, 1, 1, GP2X_VKEYB_NORMAL_KEY, 0 },
    { KEY_3,         10, 0, 1, 1, GP2X_VKEYB_NORMAL_KEY, 0 },
    { KEY_4,         11, 0, 1, 1, GP2X_VKEYB_NORMAL_KEY, 0 },
    { KEY_5,         12, 0, 1, 1, GP2X_VKEYB_NORMAL_KEY, 0 },
    { KEY_6,         13, 0, 1, 1, GP2X_VKEYB_NORMAL_KEY, 0 },
    { KEY_7,         14, 0, 1, 1, GP2X_VKEYB_NORMAL_KEY, 0 },
    { KEY_8,         15, 0, 1, 1, GP2X_VKEYB_NORMAL_KEY, 0 },
    { KEY_9,         16, 0, 1, 1, GP2X_VKEYB_NORMAL_KEY, 0 },
    { KEY_0,         17, 0, 1, 1, GP2X_VKEYB_NORMAL_KEY, 0 },
    { KEY_EQUALS,    18, 0, 1, 1, GP2X_VKEYB_NORMAL_KEY, 0 },
    { KEY_SCRLOCK,   22, 0, 4, 1, GP2X_VKEYB_NORMAL_KEY, 0 },

    /* second row */

    { KEY_Q,          9, 1, 1, 1, GP2X_VKEYB_NORMAL_KEY, 0 },
    { KEY_W,         10, 1, 1, 1, GP2X_VKEYB_NORMAL_KEY, 0 },
    { KEY_E,         11, 1, 1, 1, GP2X_VKEYB_NORMAL_KEY, 0 },
    { KEY_R,         12, 1, 1, 1, GP2X_VKEYB_NORMAL_KEY, 0 },
    { KEY_T,         13, 1, 1, 1, GP2X_VKEYB_NORMAL_KEY, 0 },
    { KEY_Y,         14, 1, 1, 1, GP2X_VKEYB_NORMAL_KEY, 0 },
    { KEY_U,         15, 1, 1, 1, GP2X_VKEYB_NORMAL_KEY, 0 },
    { KEY_I,         16, 1, 1, 1, GP2X_VKEYB_NORMAL_KEY, 0 },
    { KEY_O,         17, 1, 1, 1, GP2X_VKEYB_NORMAL_KEY, 0 },
    { KEY_P,         18, 1, 1, 1, GP2X_VKEYB_NORMAL_KEY, 0 },
    { KEY_SLASH,     19, 1, 1, 1, GP2X_VKEYB_NORMAL_KEY, 0 },

    /* third row */

    { KEY_A,         10, 2, 1, 1, GP2X_VKEYB_NORMAL_KEY, 0 },
    { KEY_S,         11, 2, 1, 1, GP2X_VKEYB_NORMAL_KEY, 0 },
    { KEY_D,         12, 2, 1, 1, GP2X_VKEYB_NORMAL_KEY, 0 },
    { KEY_F,         13, 2, 1, 1, GP2X_VKEYB_NORMAL_KEY, 0 },
    { KEY_G,         14, 2, 1, 1, GP2X_VKEYB_NORMAL_KEY, 0 },
    { KEY_H,         15, 2, 1, 1, GP2X_VKEYB_NORMAL_KEY, 0 },
    { KEY_J,         16, 2, 1, 1, GP2X_VKEYB_NORMAL_KEY, 0 },
    { KEY_K,         17, 2, 1, 1, GP2X_VKEYB_NORMAL_KEY, 0 },
    { KEY_L,         18, 2, 1, 1, GP2X_VKEYB_NORMAL_KEY, 0 },
    { KEY_COLON,     19, 2, 1, 1, GP2X_VKEYB_NORMAL_KEY, 0 },
    { KEY_ENTER,     21, 2, 5, 1, GP2X_VKEYB_NORMAL_KEY, 0 },

    /* fourth row */

    { KEY_LSHIFT,     1, 3, 5, 1, GP2X_VKEYB_TOGGLE_KEY_HL, 0 },
    { KEY_Z,         11, 3, 1, 1, GP2X_VKEYB_NORMAL_KEY, 0 },
    { KEY_X,         12, 3, 1, 1, GP2X_VKEYB_NORMAL_KEY, 0 },
    { KEY_C,         13, 3, 1, 1, GP2X_VKEYB_NORMAL_KEY, 0 },
    { KEY_V,         14, 3, 1, 1, GP2X_VKEYB_NORMAL_KEY, 0 },
    { KEY_B,         15, 3, 1, 1, GP2X_VKEYB_NORMAL_KEY, 0 },
    { KEY_N,         16, 3, 1, 1, GP2X_VKEYB_NORMAL_KEY, 0 },
    { KEY_M,         17, 3, 1, 1, GP2X_VKEYB_NORMAL_KEY, 0 },
    { KEY_COMMA,     18, 3, 1, 1, GP2X_VKEYB_NORMAL_KEY, 0 },
    { KEY_STOP,      19, 3, 1, 1, GP2X_VKEYB_NORMAL_KEY, 0 },
    { KEY_RSHIFT,    21, 3, 5, 1, GP2X_VKEYB_TOGGLE_KEY_HL, 0 },

    /* fifth row */

    { KEY_CAPSLOCK,   1, 4, 4, 1, GP2X_VKEYB_NORMAL_KEY_HL_TOGGLE, 0 },
    { KEY_LCONTROL,   6, 4, 4, 1, GP2X_VKEYB_TOGGLE_KEY_HL, 0 },
    { KEY_SPACE,     12, 4, 5, 1, GP2X_VKEYB_NORMAL_KEY, 0 },
    { KEY_F1,        21, 4, 4, 1, GP2X_VKEYB_NORMAL_KEY, 0 },         /* TODO: What does this one map to in mess?? */
};

gp2x_virtual_keyboard ti99_4a_keyboard =
{
    "ti99_4a",
    NULL,
    keyb_ti99_4a,
    shift_keyb_ti99_4a,
    keyb_ent_ti99_4a,
    sizeof( keyb_ent_ti99_4a ) / sizeof( gp2x_vkeyb_entry ),
    5,
    8,                           /* start x */
    0,                           /* start y */
    1,                           /* start w */
    1,                           /* start h */
    1,                           /* fg */
    0,                           /* bg */
    0x00FF00,                    /* cursor */
    0x0000FF,                    /* toggle */
    200,                         /* alpha */
};

///////////////////////////////////

char* keyb_coco[] = {

//   0123456789ABCDEF0123456789ABCDEF0
	"      1234567890:-  brk    <sl>  ", // 0
	" alt   qwertyuiop@  clr     up   ", // 1
	" ctrl   asdfghjkl;  enter rt  lf ", // 2
	" shift   zxcvbnm,./ shift   dn   ", // 3
	"           space    F1  F2       ", // 4
	NULL                                 // 5
};

char* shift_keyb_coco[] = {

//   0123456789ABCDEF0123456789A
	"      !\"#$%&'()0*=  esc    <sl>  ", // 0
	" alt   QWERTYUIOP@  clr     up   ", // 1
	" ctrl   ASDFGHJKL;  enter rt  lf ", // 2
	" shift   ZXCVBNM<>? shift   dn   ", // 3
	"           space    F1  F2       ", // 4
	NULL                                 // 5
};

gp2x_vkeyb_entry keyb_ent_coco[] = {

    /* first row */

    { KEY_1,         6,  0, 1, 1, GP2X_VKEYB_NORMAL_KEY, 0 },
    { KEY_2,         7,  0, 1, 1, GP2X_VKEYB_NORMAL_KEY, 0 },
    { KEY_3,         8,  0, 1, 1, GP2X_VKEYB_NORMAL_KEY, 0 },
    { KEY_4,         9,  0, 1, 1, GP2X_VKEYB_NORMAL_KEY, 0 },
    { KEY_5,         10, 0, 1, 1, GP2X_VKEYB_NORMAL_KEY, 0 },
    { KEY_6,         11, 0, 1, 1, GP2X_VKEYB_NORMAL_KEY, 0 },
    { KEY_7,         12, 0, 1, 1, GP2X_VKEYB_NORMAL_KEY, 0 },
    { KEY_8,         13, 0, 1, 1, GP2X_VKEYB_NORMAL_KEY, 0 },
    { KEY_9,         14, 0, 1, 1, GP2X_VKEYB_NORMAL_KEY, 0 },
    { KEY_0,         15, 0, 1, 1, GP2X_VKEYB_NORMAL_KEY, 0 },
    { KEY_COLON,     16, 0, 1, 1, GP2X_VKEYB_NORMAL_KEY, 0 },
    { KEY_STOP,      17, 0, 1, 1, GP2X_VKEYB_NORMAL_KEY, 0 },
    { KEY_STOP,      20, 0, 3, 1, GP2X_VKEYB_NORMAL_KEY, 0 },
    { KEY_SCRLOCK,   27, 0, 4, 1, GP2X_VKEYB_NORMAL_KEY, 0 },

    /* second row */

    { KEY_ALT,        1, 1, 3, 1, GP2X_VKEYB_TOGGLE_KEY_HL, 0 },
    { KEY_Q,          7, 1, 1, 1, GP2X_VKEYB_NORMAL_KEY, 0 },
    { KEY_W,          8, 1, 1, 1, GP2X_VKEYB_NORMAL_KEY, 0 },
    { KEY_E,          9, 1, 1, 1, GP2X_VKEYB_NORMAL_KEY, 0 },
    { KEY_R,         10, 1, 1, 1, GP2X_VKEYB_NORMAL_KEY, 0 },
    { KEY_T,         11, 1, 1, 1, GP2X_VKEYB_NORMAL_KEY, 0 },
    { KEY_Y,         12, 1, 1, 1, GP2X_VKEYB_NORMAL_KEY, 0 },
    { KEY_U,         13, 1, 1, 1, GP2X_VKEYB_NORMAL_KEY, 0 },
    { KEY_I,         14, 1, 1, 1, GP2X_VKEYB_NORMAL_KEY, 0 },
    { KEY_O,         15, 1, 1, 1, GP2X_VKEYB_NORMAL_KEY, 0 },
    { KEY_P,         16, 1, 1, 1, GP2X_VKEYB_NORMAL_KEY, 0 },
    { KEY_P,         16, 1, 1, 1, GP2X_VKEYB_NORMAL_KEY, 0 },
    { KEY_SLASH,     19, 1, 1, 1, GP2X_VKEYB_NORMAL_KEY, 0 },

    /* third row */

    { KEY_A,         10, 2, 1, 1, GP2X_VKEYB_NORMAL_KEY, 0 },
    { KEY_S,         11, 2, 1, 1, GP2X_VKEYB_NORMAL_KEY, 0 },
    { KEY_D,         12, 2, 1, 1, GP2X_VKEYB_NORMAL_KEY, 0 },
    { KEY_F,         13, 2, 1, 1, GP2X_VKEYB_NORMAL_KEY, 0 },
    { KEY_G,         14, 2, 1, 1, GP2X_VKEYB_NORMAL_KEY, 0 },
    { KEY_H,         15, 2, 1, 1, GP2X_VKEYB_NORMAL_KEY, 0 },
    { KEY_J,         16, 2, 1, 1, GP2X_VKEYB_NORMAL_KEY, 0 },
    { KEY_K,         17, 2, 1, 1, GP2X_VKEYB_NORMAL_KEY, 0 },
    { KEY_L,         18, 2, 1, 1, GP2X_VKEYB_NORMAL_KEY, 0 },
    { KEY_COLON,     19, 2, 1, 1, GP2X_VKEYB_NORMAL_KEY, 0 },
    { KEY_ENTER,     21, 2, 5, 1, GP2X_VKEYB_NORMAL_KEY, 0 },

    /* fourth row */

    { KEY_LSHIFT,     1, 3, 5, 1, GP2X_VKEYB_TOGGLE_KEY_HL, 0 },
    { KEY_Z,         11, 3, 1, 1, GP2X_VKEYB_NORMAL_KEY, 0 },
    { KEY_X,         12, 3, 1, 1, GP2X_VKEYB_NORMAL_KEY, 0 },
    { KEY_C,         13, 3, 1, 1, GP2X_VKEYB_NORMAL_KEY, 0 },
    { KEY_V,         14, 3, 1, 1, GP2X_VKEYB_NORMAL_KEY, 0 },
    { KEY_B,         15, 3, 1, 1, GP2X_VKEYB_NORMAL_KEY, 0 },
    { KEY_N,         16, 3, 1, 1, GP2X_VKEYB_NORMAL_KEY, 0 },
    { KEY_M,         17, 3, 1, 1, GP2X_VKEYB_NORMAL_KEY, 0 },
    { KEY_COMMA,     18, 3, 1, 1, GP2X_VKEYB_NORMAL_KEY, 0 },
    { KEY_STOP,      19, 3, 1, 1, GP2X_VKEYB_NORMAL_KEY, 0 },
    { KEY_RSHIFT,    21, 3, 5, 1, GP2X_VKEYB_TOGGLE_KEY_HL, 0 },

    /* fifth row */

    { KEY_CAPSLOCK,   1, 4, 4, 1, GP2X_VKEYB_NORMAL_KEY_HL_TOGGLE, 0 },
    { KEY_LCONTROL,   6, 4, 4, 1, GP2X_VKEYB_TOGGLE_KEY_HL, 0 },
    { KEY_SPACE,     12, 4, 5, 1, GP2X_VKEYB_NORMAL_KEY, 0 },
    { KEY_F1,        21, 4, 4, 1, GP2X_VKEYB_NORMAL_KEY, 0 },         /* TODO: What does this one map to in mess?? */
};

gp2x_virtual_keyboard coco_keyboard =
{
    "coco",
    NULL,
    keyb_coco,
    shift_keyb_coco,
    keyb_ent_coco,
    sizeof( keyb_ent_coco ) / sizeof( gp2x_vkeyb_entry ),
    5,
    8,                           /* start x */
    0,                           /* start y */
    1,                           /* start w */
    1,                           /* start h */
    1,                           /* fg */
    0,                           /* bg */
    0x00FF00,                    /* cursor */
    0x0000FF,                    /* toggle */
    200,                         /* alpha */
};

///////////////////////////////////

#ifdef __GP2X_HOST__
// get around truetype bug in Debian 04/01/07
char* keyb_pc[] = {
//   0123456789ABCDEF0123456789ABCDEF012
	"_esc_f1_f2_f3_f4_f5_f6_f7_f8_sl_bk_", // 0
	"___`_1_2_3_4_5_6_7_8_9_0_-_=__bs___", // 1
	"_tab__q_w_e_r_t_y_u_i_o_p_[_]_\\___", // 2
	"_caps__a_s_d_f_g_h_j_k_l_;_'_enter_", // 3
	"_shift__z_x_c_v_b_n_m_,_._/__shift_", // 4
	"_ctrl__alt___space____alt____ctrl__", // 5
	NULL                                   // 6
};
#else
char* keyb_pc[] = {
//   0123456789ABCDEF0123456789ABCDEF012
	" esc f1 f2 f3 f4 f5 f6 f7 f8 sl bk ", // 0
	"   ` 1 2 3 4 5 6 7 8 9 0 - =  bs   ", // 1
	" tab  q w e r t y u i o p [ ] \\   ", // 2
	" caps  a s d f g h j k l ; ' enter ", // 3
	" shift  z x c v b n m , . /  shift ", // 4
	" ctrl  alt   space    alt    ctrl  ", // 5
	NULL                                   // 6
};
#endif

char* shift_keyb_pc[] = {
//   0123456789ABCDEF0123456789A
	" esc f1 f2 f3 f4 f5 f6 f7 f8 sl bk ", // 0
	"   ~ ! @ # $ % ^ & * ( ) _ +  bs   ", // 1
	" tab  Q W E R T Y U I O P { } |    ", // 2
	" caps  A S D F G H J K L : \" enter ", // 3
	" shift  Z X C V B N M < > ?  shift ", // 4
	" ctrl  alt   space    alt    ctrl  ", // 5
	NULL                                   // 6
};

gp2x_vkeyb_entry keyb_ent_pc[] = {

    /* first row */

    { KEY_ESC,        1,  0, 3, 1, GP2X_VKEYB_NORMAL_KEY, 0 },
    { KEY_F1,         5,  0, 2, 1, GP2X_VKEYB_NORMAL_KEY, 0 },
    { KEY_F2,         8,  0, 2, 1, GP2X_VKEYB_NORMAL_KEY, 0 },
    { KEY_F3,        11,  0, 2, 1, GP2X_VKEYB_NORMAL_KEY, 0 },
    { KEY_F4,        14,  0, 2, 1, GP2X_VKEYB_NORMAL_KEY, 0 },
    { KEY_F5,        17,  0, 2, 1, GP2X_VKEYB_NORMAL_KEY, 0 },
    { KEY_F6,        20,  0, 2, 1, GP2X_VKEYB_NORMAL_KEY, 0 },
    { KEY_F7,        23,  0, 2, 1, GP2X_VKEYB_NORMAL_KEY, 0 },
    { KEY_F8,        26,  0, 2, 1, GP2X_VKEYB_NORMAL_KEY, 0 },
    { KEY_SCRLOCK,   29,  0, 2, 1, GP2X_VKEYB_NORMAL_KEY, 0 },
    { KEY_PAUSE,     32,  0, 2, 1, GP2X_VKEYB_NORMAL_KEY, 0 },	

    /* second row */

    { KEY_TILDE,      3,  1, 1, 1, GP2X_VKEYB_NORMAL_KEY, 0 },
    { KEY_1,          5,  1, 1, 1, GP2X_VKEYB_NORMAL_KEY, 0 },
    { KEY_2,          7,  1, 1, 1, GP2X_VKEYB_NORMAL_KEY, 0 },
    { KEY_3,          9,  1, 1, 1, GP2X_VKEYB_NORMAL_KEY, 0 },
    { KEY_4,          11, 1, 1, 1, GP2X_VKEYB_NORMAL_KEY, 0 },
    { KEY_5,          13, 1, 1, 1, GP2X_VKEYB_NORMAL_KEY, 0 },
    { KEY_6,          15, 1, 1, 1, GP2X_VKEYB_NORMAL_KEY, 0 },
    { KEY_7,          17, 1, 1, 1, GP2X_VKEYB_NORMAL_KEY, 0 },
    { KEY_8,          19, 1, 1, 1, GP2X_VKEYB_NORMAL_KEY, 0 },
    { KEY_9,          21, 1, 1, 1, GP2X_VKEYB_NORMAL_KEY, 0 },
    { KEY_0,          23, 1, 1, 1, GP2X_VKEYB_NORMAL_KEY, 0 },
    { KEY_MINUS,      25, 1, 1, 1, GP2X_VKEYB_NORMAL_KEY, 0 },
    { KEY_EQUALS,     27, 1, 1, 1, GP2X_VKEYB_NORMAL_KEY, 0 },
    { KEY_BACKSPACE,  30, 1, 2, 1, GP2X_VKEYB_NORMAL_KEY, 0 },

    /* third row */

    { KEY_TAB,        1, 2, 3, 1, GP2X_VKEYB_NORMAL_KEY, 0 },
    { KEY_Q,          6, 2, 1, 1, GP2X_VKEYB_NORMAL_KEY, 0 },
    { KEY_W,          8, 2, 1, 1, GP2X_VKEYB_NORMAL_KEY, 0 },
    { KEY_E,         10, 2, 1, 1, GP2X_VKEYB_NORMAL_KEY, 0 },
    { KEY_R,         12, 2, 1, 1, GP2X_VKEYB_NORMAL_KEY, 0 },
    { KEY_T,         14, 2, 1, 1, GP2X_VKEYB_NORMAL_KEY, 0 },
    { KEY_Y,         16, 2, 1, 1, GP2X_VKEYB_NORMAL_KEY, 0 },
    { KEY_U,         18, 2, 1, 1, GP2X_VKEYB_NORMAL_KEY, 0 },
    { KEY_I,         20, 2, 1, 1, GP2X_VKEYB_NORMAL_KEY, 0 },
    { KEY_O,         22, 2, 1, 1, GP2X_VKEYB_NORMAL_KEY, 0 },
    { KEY_P,         24, 2, 1, 1, GP2X_VKEYB_NORMAL_KEY, 0 },
    { KEY_OPENBRACE, 26, 2, 1, 1, GP2X_VKEYB_NORMAL_KEY, 0 },
    { KEY_CLOSEBRACE, 28, 2, 1, 1, GP2X_VKEYB_NORMAL_KEY, 0 },
    { KEY_BACKSLASH, 30, 2, 1, 1, GP2X_VKEYB_NORMAL_KEY, 0 },

    /* fourth row */

    { KEY_CAPSLOCK,   1, 3, 4, 1, GP2X_VKEYB_NORMAL_KEY_HL_TOGGLE, 0 },
    { KEY_A,          7, 3, 1, 1, GP2X_VKEYB_NORMAL_KEY, 0 },
    { KEY_S,          9, 3, 1, 1, GP2X_VKEYB_NORMAL_KEY, 0 },
    { KEY_D,         11, 3, 1, 1, GP2X_VKEYB_NORMAL_KEY, 0 },
    { KEY_F,         13, 3, 1, 1, GP2X_VKEYB_NORMAL_KEY, 0 },
    { KEY_G,         15, 3, 1, 1, GP2X_VKEYB_NORMAL_KEY, 0 },
    { KEY_H,         17, 3, 1, 1, GP2X_VKEYB_NORMAL_KEY, 0 },
    { KEY_J,         19, 3, 1, 1, GP2X_VKEYB_NORMAL_KEY, 0 },
    { KEY_K,         21, 3, 1, 1, GP2X_VKEYB_NORMAL_KEY, 0 },
    { KEY_L,         23, 3, 1, 1, GP2X_VKEYB_NORMAL_KEY, 0 },
    { KEY_COLON,     25, 3, 1, 1, GP2X_VKEYB_NORMAL_KEY, 0 },
    { KEY_QUOTE,     27, 3, 1, 1, GP2X_VKEYB_NORMAL_KEY, 0 },
    { KEY_ENTER,     29, 3, 5, 1, GP2X_VKEYB_NORMAL_KEY, 0 },

    /* fifth row */

    { KEY_LSHIFT,     1, 4, 5, 1, GP2X_VKEYB_TOGGLE_KEY_HL, 0 },
    { KEY_Z,          8, 4, 1, 1, GP2X_VKEYB_NORMAL_KEY, 0 },
    { KEY_X,         10, 4, 1, 1, GP2X_VKEYB_NORMAL_KEY, 0 },
    { KEY_C,         12, 4, 1, 1, GP2X_VKEYB_NORMAL_KEY, 0 },
    { KEY_V,         14, 4, 1, 1, GP2X_VKEYB_NORMAL_KEY, 0 },
    { KEY_B,         16, 4, 1, 1, GP2X_VKEYB_NORMAL_KEY, 0 },
    { KEY_N,         18, 4, 1, 1, GP2X_VKEYB_NORMAL_KEY, 0 },
    { KEY_M,         20, 4, 1, 1, GP2X_VKEYB_NORMAL_KEY, 0 },
    { KEY_COMMA,     22, 4, 1, 1, GP2X_VKEYB_NORMAL_KEY, 0 },
    { KEY_STOP,      24, 4, 1, 1, GP2X_VKEYB_NORMAL_KEY, 0 },
    { KEY_SLASH,     26, 4, 1, 1, GP2X_VKEYB_NORMAL_KEY, 0 },
    { KEY_RSHIFT,    29, 4, 5, 1, GP2X_VKEYB_TOGGLE_KEY_HL, 0 },

    /* sixth row */

    { KEY_LCONTROL,   1, 5, 4, 1, GP2X_VKEYB_TOGGLE_KEY_HL, 0 },
    { KEY_ALT,        7, 5, 3, 1, GP2X_VKEYB_TOGGLE_KEY_HL, 0 },
    { KEY_SPACE,     13, 5, 5, 1, GP2X_VKEYB_NORMAL_KEY, 0 },
    { KEY_ALT,       22, 5, 3, 1, GP2X_VKEYB_TOGGLE_KEY_HL, 0 },
    { KEY_RCONTROL,  29, 5, 4, 1, GP2X_VKEYB_TOGGLE_KEY_HL, 0 },
};

gp2x_virtual_keyboard pc_keyboard =
{
    "PC",
    "res/fs_dlg.ttf",
    12,
    NULL,
    keyb_pc,
    shift_keyb_pc,
    keyb_ent_pc,
    sizeof( keyb_ent_pc ) / sizeof( gp2x_vkeyb_entry ),
    6,
    13,                          /* start x */
    5,                           /* start y */
    5,                           /* start w */
    1,                           /* start h */
    0xFFFFFF,                    /* fg */
    0,                           /* bg */
    0x00FF00,                    /* cursor */
    0x0000FF,                    /* toggle */
    200,                         /* alpha */
};

char* keyb_coleco[] = {

//   0123456789ABCDEF0123456789A
	"            123            ", // 0
	"            456            ", // 1
	"            789            ", // 2
	"            #0*            ", // 3
	NULL                           // 4
};

char* shift_keyb_coleco[] = {

//   0123456789ABCDEF0123456789A
	"            123            ", // 0
	"            456            ", // 1
	"            789            ", // 2
	"            #0*            ", // 3
	NULL                           // 4
};

gp2x_vkeyb_entry keyb_ent_coleco[] = {

    /* first row */

    { KEY_1,         12, 0, 1, 1, GP2X_VKEYB_NORMAL_KEY, 0 },
    { KEY_2,         13, 0, 1, 1, GP2X_VKEYB_NORMAL_KEY, 0 },
    { KEY_3,         14, 0, 1, 1, GP2X_VKEYB_NORMAL_KEY, 0 },

    /* second row */

    { KEY_4,         12, 1, 1, 1, GP2X_VKEYB_NORMAL_KEY, 0 },
    { KEY_5,         13, 1, 1, 1, GP2X_VKEYB_NORMAL_KEY, 0 },
    { KEY_6,         14, 1, 1, 1, GP2X_VKEYB_NORMAL_KEY, 0 },

    /* third row */

    { KEY_7,         12, 2, 1, 1, GP2X_VKEYB_NORMAL_KEY, 0 },
    { KEY_8,         13, 2, 1, 1, GP2X_VKEYB_NORMAL_KEY, 0 },
    { KEY_9,         14, 2, 1, 1, GP2X_VKEYB_NORMAL_KEY, 0 },

    /* fourth row */

    { KEY_EQUALS,    12, 3, 1, 1, GP2X_VKEYB_NORMAL_KEY, 0 },
    { KEY_0,         13, 3, 1, 1, GP2X_VKEYB_NORMAL_KEY, 0 },
    { KEY_MINUS,     14, 3, 1, 1, GP2X_VKEYB_NORMAL_KEY, 0 },
};

gp2x_virtual_keyboard coleco_keyboard =
{
    "coleco",
    "res/fs_dlg.ttf",
    22,
    NULL,
    keyb_coleco,
    shift_keyb_coleco,
    keyb_ent_coleco,
    sizeof( keyb_ent_coleco ) / sizeof( gp2x_vkeyb_entry ),
    4,
    12,                          /* start x */
    0,                           /* start y */
    1,                           /* start w */
    1,                           /* start h */
    0xFFFFFF,                    /* fg */
    0,                           /* bg */
    0x00FF00,                    /* cursor */
    0x0000FF,                    /* toggle */
    200,                         /* alpha */
};
