#ifndef __GP2X_VKEY_H__
#define __GP2X_VKEY_H__

#include "SDL.h"
#include "SDL_ttf.h"

#define GP2X_VKEYB_NORMAL_KEY             0
#define GP2X_VKEYB_TOGGLE_KEY_HL          1
#define GP2X_VKEYB_NORMAL_KEY_HL_TOGGLE   2

///////////////////////////////////

typedef struct
{
    int keycode;
    int x;
    int y;
    int width;
    int height;
    int key_behav;
    int last_state;

} gp2x_vkeyb_entry;

///////////////////////////////////

typedef struct
{
    char* name;

    char* font_file;
    int font_size;
    TTF_Font* font;

    char** keyboard;
    char** shift_keyb;      /* must be same keys, just different visual */
    gp2x_vkeyb_entry* entries;
    int num_vkeyb_entries;
    int num_vkeyb_rows;

    int start_x;
    int start_y;
    int start_width;
    int start_height;

    int fg_color;
    int bg_color;

    int cursor_color;
    int toggle_color;

    int alpha;

} gp2x_virtual_keyboard;

///////////////////////////////////

extern void gp2x_vkeyb_init( gp2x_virtual_keyboard* keyb );
extern void gp2x_vkeyb_cleanup( void );
extern void gp2x_vkeyb_draw( SDL_Surface* screen, gp2x_virtual_keyboard* keyb );
extern void gp2x_vkeyb_handle_input( int button_pressed, gp2x_virtual_keyboard* keyb );
extern void gp2x_vkeyb_clear_display( SDL_Surface* screen );
extern void gp2x_vkeyb_pump_event( void );

extern int gp2x_display_vkeyb;
extern int gp2x_clean_up_keyboard;

#endif   /* __GP2X_VKEY_H__ */
